package com.citygis.jiami;

import com.baomidou.mybatisplus.core.toolkit.CollectionUtils;
import com.citygis.pojo.ColumnInfo;
import com.citygis.utils.Sm4Util;
import org.bouncycastle.jcajce.provider.symmetric.SM4;
import org.springframework.web.bind.annotation.CrossOrigin;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestParam;

import com.citygis.utils.SM42;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import java.util.List;

@RestController
@CrossOrigin
public class JiaMiController {

    @Resource
    JiaMiService jiaMiService;

    /**
     * @param tableName 表名
     * @param column    字段名
     * @return
     * @throws Exception
     */
    @GetMapping(value = "/handleEncryption")
    public String handleEncryption(@RequestParam("id") String id, @RequestParam("tableName") String tableName, @RequestParam("column") String column) throws Exception {

        List<ColumnInfo> columnList = jiaMiService.handleEncryption(id, tableName, column);
//        // 获取秘钥
//        String sm4Key = Sm4Util.getSm4Key();
//        System.out.println("sm4秘钥:" + sm4Key);

        int row = 0;
        if (!CollectionUtils.isEmpty(columnList) && columnList.size() > 0) {
            for (ColumnInfo info : columnList) {
                String encryString = Sm4Util.encrypt(info.getValue(), "892575e584e5b5d740159a3fd1982c56");
                row = row + jiaMiService.updateEncryption(tableName, column, info.getId(), encryString);
            }
        }
        return "成功" + row + "行";
    }

}
