package com.citygis.qianMing;

import com.alibaba.fastjson2.JSONObject;
import com.baomidou.mybatisplus.core.toolkit.StringUtils;
import com.citygis.mapper.QianMingMapper;
import com.citygis.pojo.QianMingBaoAddress;
import com.citygis.utils.SignUtils;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.io.FileInputStream;
import java.io.IOException;
import java.security.MessageDigest;
import java.util.List;

@Service
public class QianMingServiceimpl implements QianMingService {

    @Resource
    QianMingMapper qianMingMapper;

    @Override
    public String qianMing() {

        List<QianMingBaoAddress> qianMingBaoAddressList = qianMingMapper.getQianMingBaoAddressList();

        qianMingBaoAddressList.forEach(qianMingBaoAddress -> {
            // 文件签名
            String sign = null;
            String respType = null;
            String filePath = qianMingBaoAddress.getAddress();
            String utf8String = getFileHash(filePath);
            JSONObject resultJson = null;
            try {
                resultJson = SignUtils.getSign(utf8String, "cd");
            } catch (IOException e) {
                throw new RuntimeException(e);
            }

            if (resultJson == null) {
                System.out.println("获取签名错误！");
            } else {
                JSONObject responseJson = resultJson.getJSONObject("response");
                sign = responseJson.getString("signature");
                respType = resultJson.getString("respType");
                System.out.println("签名值为：" + sign);
                System.out.println("签名响应格式：" + respType);

                qianMingBaoAddress.setSign(sign);
                qianMingBaoAddress.setRespType(respType);
                qianMingMapper.addQianMing(qianMingBaoAddress);
            }
        });

        return "签名成功";
    }

    @Override
    public String yanQian() {
        List<QianMingBaoAddress> qianMingBaoAddressList = qianMingMapper.getQianMingBaoAddressList();

        qianMingBaoAddressList.forEach(qianMingBaoAddress -> {
            String filePath = qianMingBaoAddress.getAddress();
            String utf8String = getFileHash(filePath);

            String sign = qianMingBaoAddress.getSign();
            String respType = qianMingBaoAddress.getRespType();
            if (!StringUtils.isEmpty(sign) && !StringUtils.isEmpty(respType)) {
                JSONObject verfityResultJson = null;
                try {
                    verfityResultJson = SignUtils.verifySign(respType, sign.replaceAll(" ", "+"), utf8String, "cd");
                } catch (IOException e) {
                    throw new RuntimeException(e);
                }
                if (verfityResultJson == null) {
                    System.out.println("验签错误！");
                } else {
                    JSONObject responseJson = verfityResultJson.getJSONObject("response");
                    if (!StringUtils.isEmpty(responseJson.getString("respValue")) && responseJson.getString("respValue").equals("0")) {
                        System.out.println("验签成功！");
                    } else {
                        System.out.println("验签失败！");
                    }
                }
            }
        });
        return "";
    }

    // 获取文件hash
    public String getFileHash(String path) {

        StringBuffer sb = new StringBuffer();
        try {
            MessageDigest md = MessageDigest.getInstance("MD5");
            FileInputStream fis = new FileInputStream(path);
            byte[] buff = new byte[8192];
            int length;
            while ((length = fis.read(buff)) != -1) {
                md.update(buff, 0, length);
            }
            fis.close();
            byte[] digest = md.digest();

            for (byte b : digest) {
                sb.append(String.format("%02x", b));
            }
        } catch (Exception e) {
            e.printStackTrace();
        }

        return sb.toString();
    }
}
