package com.citygis.utils;


import com.alibaba.fastjson2.JSONObject;
import org.apache.tomcat.util.codec.binary.Base64;

import javax.crypto.Cipher;
import javax.crypto.spec.IvParameterSpec;
import javax.crypto.spec.SecretKeySpec;
import java.security.AlgorithmParameters;
import java.util.HashMap;
import java.util.Map;


/**
 * @author zyl
 * @date 2023-11-09 14:33
 */

/**
 * AES 加密工具类
 */
public class AesUtil {
    //前后端约定的 key
    private static final String KEY = "opad4351dk5f09604";
    //参数分别代表 算法名称/加密模式/数据填充方式
    private static String algorithmStr = "AES/CBC/PKCS5Padding";
    //偏移量
    private static String offsetStr = "opad4351dk5f09604";
    private static byte[] ivByte = offsetStr.getBytes();

    /**
     * 加密
     * @param content 加密的字符串
     * @param encryptKey key值
     * @return
     * @throws Exception
     */
    public static String encrypt(String content, String encryptKey) throws Exception {
        /* Cipher类提供了针对加密和解密的密码  encrypt mode（加密模式） */
        Cipher cipher = Cipher.getInstance(algorithmStr);
        cipher.init(Cipher.ENCRYPT_MODE, new SecretKeySpec(encryptKey.getBytes(), "AES"),generateIV(ivByte));
        byte[] b = cipher.doFinal(content.getBytes("utf-8"));
        // 采用base64算法进行转码,避免出现中文乱码
        return Base64.encodeBase64String(b);
    }


    /**
     * 解密
     * @param encryptStr 解密的字符串
     * @param decryptKey key值
     * @return
     * @throws Exception
     */
    public static String decrypt(String encryptStr, String decryptKey) throws Exception {
        /* Cipher类提供了针对加密和解密的密码  decrypt mode（解密模式） */
        Cipher cipher = Cipher.getInstance(algorithmStr);
        cipher.init(Cipher.DECRYPT_MODE, new SecretKeySpec(decryptKey.getBytes(), "AES"), generateIV(ivByte));
        // 采用base64算法进行转码,避免出现中文乱码
        byte[] encryptBytes = Base64.decodeBase64(encryptStr);
        byte[] decryptBytes = cipher.doFinal(encryptBytes);
        return new String(decryptBytes);
    }

    public static String myEncrypt(String content) throws Exception {
        return encrypt(content, KEY);
    }
    public static  String myDecrypt(String encryptStr) throws Exception {
        return decrypt(encryptStr, KEY);
    }

    // 生成iv（应该就是偏移量）
    public static AlgorithmParameters generateIV(byte[] iv) throws Exception {
        AlgorithmParameters params = AlgorithmParameters.getInstance("AES");
        params.init(new IvParameterSpec(iv));
        return params;
    }


    public static void main(String[] args) {
        Map map=new HashMap<String,String>();
        map.put("中文","value");
        map.put("hello","world");
        String content = JSONObject.toJSONString(map);

        System.out.println("加密前：" + content);
        try {
            String encrypt = AesUtil.myEncrypt("DA292230F06B6992E81B0285C2224D10");
            System.out.println("加密后：" + encrypt);

            String decrypt = AesUtil.myDecrypt("0B81807AA321238A9A801B83CF924D8A");
            System.out.println("解密后：" + decrypt);
        }catch (Exception e){
            e.printStackTrace();
        }
    }
}

