package com.citygis.utils;

import javax.crypto.KeyGenerator;
import java.security.Key;
import java.security.NoSuchAlgorithmException;
import java.security.NoSuchProviderException;

//使用索引号码构造对称密钥对象
public class GenerateInternalKey {


    /**
     * @param alg      对称算法
     * @param keyIndex 密钥的索引号码
     * @return
     */
    public static Key genKey(String alg, int keyIndex) {
        KeyGenerator keyGenerator = null;
        Key key = null;
        try {
            // 密钥生成器对象实例化
            keyGenerator = KeyGenerator.getInstance(alg, "SwxaJCE");

            // 初始化密钥对生成器
            keyGenerator.init(keyIndex << 16);

            // 构造密钥
            key = keyGenerator.generateKey();

            // 判断密钥是否生成成功
            if (key == null) {
                System.out.println("生成密钥失败.");
            } else {
                // 生成密钥成功。
                System.out.println("生成密钥成功.");
                System.out.println("密钥：\n" + key.toString());
            }
        } catch (NoSuchAlgorithmException e) {
            // 该异常为找不到传入的算法，通过e.getMessage()可获取异常信息
            e.printStackTrace();
        } catch (NoSuchProviderException e) {
            // 该异常为找不到传入的提供者，通过e.getMessage()可获取异常信息
            System.out.println("No Such Provider:" + e.getMessage());
        }

        return key;
    }
}


