package com.citygis.utils;

import cn.hutool.crypto.symmetric.SM4;
import lombok.SneakyThrows;

import java.security.*;

public class SM42 extends SM4 {

    //SM4对称算法加解密模式在此选用ECB模式不填充 ，具体选择以实际应用中为准
    private final static String mode = "ECB";

    //选择填充模式，在此选择填充
    private final static String padding = "PKCS5PADDING";

    private final static String alg = "SM4";

    private final static int keyIndex = 1;//密钥索引号码

    private final static Key key = GenerateInternalKey.genKey(alg, keyIndex);

    /**
     * 加密
     */
    @Override
    @SneakyThrows
    public String encryptHex(String plain) {

        String encryptString = AesUtil.myEncrypt(plain);

        System.out.println("Base64后的密文：" + encryptString);
        return encryptString;
    }

    /**
     * 解密
     */
    @Override
    @SneakyThrows
    public String decryptStr(String encdeta) {

        String decryptString = AesUtil.myDecrypt(encdeta);

        System.out.println("解密得到的明文为:" + decryptString);
        return decryptString;

    }
}